Subject: Re: SCSI I/O performance problems when CONFIG_HIGHIO is off
From: Jens Axboe <[email-masked]>
To: Steve Lord <[email-masked]>
Cc: Linux Kernel <[email-masked]>
Date: Mon, 18 Nov 2002 13:05:31 +0100

On Fri, Nov 15 2002, Steve Lord wrote:
> Jens,
> 
> As you know, for the last week or so I have been battling some
> performance issues in XFS and 2.4.20-rc1. Well, we finally found
> the culprit back in 2.4.20-pre2.
> 
> When the block highmem patch was included, it added highmem_io to the
> scsi controller structure. This can only ever be set to one if
> CONFIG_HIGHIO is set. Yet there are several spots in the scsi
> code which test based on its value regardless.
> 
>         /*
>          * we really want to use sg even for a single segment request,
>          * however some people just cannot be bothered to write decent
>          * driver code so we can't risk to break somebody making the
>          * assumption that sg requests will always contain at least 2
>          * segments. if the driver is 32-bit dma safe, then use sg for
>          * 1 entry anyways. if not, don't rely on the driver handling this
>          * case.
>          */
>         if (count == 1 && !SCpnt->host->highmem_io) {
>                 this_count = req->current_nr_sectors;
>                 goto single_segment;
>         }

Steve,

Something isn't quite making sense. If we go over every single instance
of checking ->highmem_io, they all look sane (ie checking on non-highmem
setup must yield 0). So that part looks good.

However, I think a typo snuck in there, in exactly the spot you pasted
above. Could you try 2.4.20-rc2 with this patch applied?

===== drivers/scsi/scsi_merge.c 1.9 vs edited =====
--- 1.9/drivers/scsi/scsi_merge.c	Mon Sep 16 09:25:10 2002
+++ edited/drivers/scsi/scsi_merge.c	Mon Nov 18 13:04:41 2002
@@ -835,7 +835,7 @@
 	 * case.
  	 */
 	if (count == 1 && !SCpnt->host->highmem_io) {
-		this_count = req->current_nr_sectors;
+		this_count = req->nr_sectors;
 		goto single_segment;
 	}

-- 
Jens Axboe

-
To unsubscribe from this list: send the line "unsubscribe linux-kernel" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Please read the FAQ at  http://www.tux.org/lkml/